﻿---
author:
- Sof &lt;<hellosof@gmail.com>&gt;
autonumber-headings: 1
css:
- style.css
date: Friday, July 17, 2020
extratags: 1
extratags-back: 0
filename: doc_ru
include-after:
- '%addonDir%/doc/dependencies.md'
keywords: documentation, MarkdownForever, NVDA add-on, russian
lang: ru
langd: ru
subtitle: Полнофункциональный конвертер Markdown и HTML для NVDA
template: default
title: Документация для дополнения MarkdownForever %addonVersion%
toc: 1
...

**Оглавление**
%toc%


## Введение

MarkdownForever - это небольшое дополнение для NVDA, которое легко конвертирует содержимое Markdown или HTML. Просто напишите или отобразите любой текст в формате Markdown или HTML и нажмите простую комбинацию клавиш для мгновенного преобразования или предварительного просмотра результата в любое время, точно так, как он будет выглядеть на вашей конечной веб-странице, или в исходном коде HTML, готовом для вставки в любую текстовую область, поддерживающую HTML.

MarkdownForever может:

* Конвертировать Markdown в HTML
* Конвертировать Markdown в исходный код HTML
* Конвертировать HTML в Markdown
* Конвертировать Markdown в форматированный HTML.

## Но что же это за штука такая - Markdown?

Согласно Википедии,

> Markdown - это легкий язык разметки с синтаксисом форматирования обычного текста. Его конструкция позволяет конвертировать его во множество форматов, но оригинальный одноименный инструмент поддерживает только HTML. Markdown часто используется для форматирования файлов readme, для написания сообщений в онлайновых дискуссионных форумах и для создания насыщенного текста с помощью обычного текстового редактора.

Вы можете узнать больше о Markdown, прочитав [полную статью в Википедии](https://en.wikipedia.org/wiki/Markdown).

Таким образом, вместо того чтобы писать веб-документы с помощью HTML, рискуя наделать ошибок, вы будете использовать легко запоминающиеся теги, и ваша работа будет сделана в кратчайшие сроки. С помощью Markdown вы сможете делать более или менее то, что умеет HTML: заголовки, упорядоченные (нумерованные) или неупорядоченные (пустые) списки, ссылки и даже таблицы.

Например, если вы хотите создать заголовок первого уровня, напишите один знак "решётка" (#), а затем название вашего заголовка, с пробелом или без него:

> `#Это пример заголовка первого уровня`

который в конечном HTML-документе будет выглядеть следующим образом:

> <h1>\!Это пример заголовка первого уровня</h1>.

Для заголовка второго уровня вы будете использовать две решётки, для третьего - три и так далее.
 
Теперь давайте создадим неупорядоченный список элементов. Для этого вы можете снабдить все элементы списка звёздочкой (*). Вот пример:

<blockquote>

```
* Апельсин
* Сахар
* Молоко
```

</blockquote>

что будет выглядеть следующим образом:

> * Апельсин
> * Сахар
> * Молоко

Вы также можете сделать ссылку, заключив название ссылки в квадратные скобки ([]), а затем URL, заключенный в круглые скобки без пробелов. Например:

    [Нажмите здесь, чтобы посетить сайт NVAccess](https://www.nvaccess.org)

что даст вам:

[Нажмите здесь, чтобы посетить веб-сайт NVAccess](https://www.nvaccess.org).
 
Вы даже можете выделить `*некоторый текст курсивом*`, заключив его в звёздочки, или `**написать текст жирным**`, окружив его двумя звёздочками... Возможности многочисленны. Просто посмотрите эту [Шпаргалка для Markdown](https://www.markdownguide.org/cheat-sheet/), чтобы узнать больше тегов и подробностей.

## Преобразование Markdown в HTML

Эта функция позволяет преобразовать любой текст в формате Markdown, отображаемый на экране, в HTML, показывая вам, как ваш Markdown будет выглядеть в конечном HTML-документе. Это может быть документ, написанный вами в формате Markdown, файл .md, который уже есть на вашем жестком диске, или текст в формате Markdown, найденный на веб-странице. По умолчанию MarkdownForever преобразует весь отображаемый в данный момент текст, но вы можете выбрать только определённую часть, которая будет преобразована.

Для этого можно использовать следующие команды:

- *NVDA+ALT+b*: Результат отображается в виде веб-страницы в веб-браузере по умолчанию.
- *NVDA+ALT+n*: Результат отображается в виде веб-страницы в виртуальном просмотрщике NVDA.

Обратите внимание, что рекомендуется отдавать предпочтение отображению в браузере, а не в виртуальном просмотрщике NVDA. Некоторые теги, в частности теги HTML5, такие как `<details>,`, не поддерживаются рендерингом виртуального просмотрщика.

## Преобразование Markdown в исходный код HTML

Эта функция преобразует текст Markdown в чистый язык HTML. После этого вы сможете скопировать и вставить его в HTML-файл, в сообщение на форуме или в любую текстовую область в Интернете, где поддерживается HTML-код.

Доступны следующие команды:

- *NVDA+ALT+l*: Результат отображается в виртуальном просмотрщике NVDA.
- *NVDA+Ctrl+h*: Копирование исходного кода HTML в буфер обмена.

## Преобразование HTML в Markdown

Эта функция пытается создать текст в формате Markdown из исходного кода HTML. Как обычно, она работает со всем текстом, отображаемым на экране, или с определённой выделенной частью. Доступны следующие команды:

- *NVDA+Alt+k*: Отображает результат в виртуальном просмотрщике NVDA.
- *NVDA+Shift+g*: Копирование результата в буфер обмена.

Вы также можете преобразовать веб-страницу HTML в Markdown, просто выбрав её URL. Однако сначала необходимо убедиться, что механизм преобразования HTML2Text установлен по умолчанию в настройках [MarkdownForever,] (#markdownforevers-default-settings), расположенных в подменю Settings (Настройки) NVDA.
 
## Преобразование Markdown в форматированный HTML

Эта функция преобразует содержимое Markdown в форматированный HTML и копирует его в буфер обмена. Форматированный HTML будет выглядеть как любая веб-страница, отображаемая вашим браузером, с кликабельными ссылками, заголовками и т. д. Он может быть сгенерирован только из содержимого Markdown. Он не работает с исходным кодом HTML. Чтобы выполнить это действие, нажмите NVDA+Shift+h.

Обратите внимание, что *форматированный HTML* можно вставить в такие приложения, как Microsoft Word, Wordpad, Thunderbird, в какое-нибудь текстовое поле на веб-странице и т. д. Однако его нельзя вставить в текстовый редактор, например Блокнот, Notepad++ и другие.

## Интерактивный режим

Интерактивный режим - это функция, которая представляет все возможности MarkdownForever в удобном диалоговом окне, предлагая вам еще больше удобных дополнений. Чтобы открыть интерактивный режим, нажмите NVDA+CTRL+i.


* "Конвертировать в": Этот первый комбинированный список позволяет выбрать направление преобразования: HTML, HTML-источник или Markdown. Для выбора используйте клавиши-стрелки вверх и вниз.
* "Создавать оглавление": Этот флажок позволит вам создать или не создавать оглавление глав вашего конечного HTML-документа с кликабельными ссылками, ведущими к каждой главе. Статус этой опции также может быть установлен по умолчанию в [Настройках MarkdownForever.](#markdownforevers-default-settings)
* "Пытаться автоматически нумеровать заголовки": Если флажок установлен, Markdown Forever попытается пронумеровать ваши заголовки (или главы) в соответствии с уровнем каждого заголовка, например, "1." для заголовка уровня 1, "1.1." для заголовка уровня 2 и т. д. 
* "Включить дополнительные теги": Если эта опция отмечена, она включает возможность использования [специальных тегов](#extra-tags) в вашем контенте Markdown для автоматической вставки таких вещей, как фактическая дата или время. Статус этой опции также может быть установлен по умолчанию в [настройках MarkdownForever.](#markdownforevers-default-settings)
* "Разрешить обратный перевод дополнительных тегов": Указывает, следует ли возвращать [extra-tags](#extra-tags) к их первоначальному виду (например, %date%) при преобразовании HTML-контента, сгенерированного Markdown Forever, обратно в Markdown. 
* "Заголовок": Здесь вы можете ввести заголовок вашего HTML-документа, который будет виден в интернет-браузере.
* "Соответствующий блок метаданных": Это поле, доступное только для чтения. 
* "Создавать соответствующие метаданные из HTML-источника": При конвертировании исходного HTML-файла в Markdown он пытается угадать метаданные из исходного кода (название, lang, имя файла и т. д.) и сгенерировать для вас блок [метаданных](#optionnal-metadata-block). Эта опция доступна только для преобразования HTML в Markdown.
* "Показать в виртуальном просмотрщике": Эта кнопка откроет преобразованный контент в виртуальном просмотрщике NVDA.
* "Показать в браузере": Эта кнопка отобразит преобразованный контент в интернет-браузере по умолчанию.
* "Скопировать в буфер обмена": Это поместит преобразованный контент в буфер обмена Windows, готовый к вставке.
* "Сохранить как": В этом случае вам будет предложено сохранить преобразованный документ на жёстком диске с помощью стандартного диалогового окна "Сохранить как". Место сохранения по умолчанию также может быть задано в [настройках MarkdownForever](#markdownforevers-default-settings).

## Дополнительный блок метаданных

Блок метаданных позволяет задать специфические параметры для конкретного документа, не зависящие от [настроек по умолчанию](#markdownforevers-default-settings). Он должен располагаться в самом начале документа и начинаться с трех тире ("---") и заканчиваться тремя точками ("...") или тремя тире ("---"). Каждая запись должна быть введена в следующем виде: ключ: "значение" (значение должно быть заключено в кавычки). После блока метаданных должна присутствовать пустая строка.

### Список поддерживаемых метаданных

* Автор (или авторы): Чтобы указать имя одного или нескольких авторов для документа (см. пример ниже). Они будут добавлены в заголовок HTML-файла. Этот ключ не чувствителен к регистру.
* autonumber-headings (автонумерация заголовков): Указывает, следует ли нумеровать заголовки автоматически. Возможные значения: true (1) или false (0).
* css (или CSS): Указывает один или несколько файлов CSS для оформления документа (см. пример ниже). Этот ключ не чувствителен к регистру.
* date (или CSS): чтобы указать дату для вашего документа. Она будет добавлена в заголовок HTML-файла.
* extratags: чтобы указать, следует ли интерпретировать [extra-tags](#extra-tags). Возможные значения: true (1) или false (0).
* extratags-back: Указывает, следует ли возвращать [extra-tags](#extra-tags) к их первоначальному виду (например, %date%) при преобразовании HTML-контента, сгенерированного Markdown Forever, обратно в Markdown. Возможные значения: true (1) или false (0).
* filename: указать имя выходного файла при сохранении.
* keywords: Указать ключевые слова, относящиеся к теме (темам) вашего документа.
* lang: указать основной язык документа. При необходимости используйте теги span/div с атрибутом lang для указания изменений языка внутри документа.
* path: указать каталог, в котором должен быть сгенерирован документ. Поддерживаются переменные окружения %userprofile%, %appdata% и %tmp%.
* subtitle: Указать подзаголовок для HTML-документа. Он будет добавлен в заголовок HTML-файла.
* title: указать заголовок HTML-документа. В интерактивном режиме поле заголовка будет автоматически заполнено значением этого ключа.
* toc: указывает, должно ли создаваться оглавление. Возможные значения: true (1) или false (0).

### Пример использования метаданных
<blockquote>

```
---
title: "a simple title"
date: 2019-11-08
subtitle: "this is the subtitle of your document"
lang: en
author:
- John Doe
- David Murphy
CSS:
- %userprofile%/document/main.css
- %userprofile%/document/custom.css
keywords: NVDA, Markdown, HTML
filename: test
path: "%userprofile%/desktop"
toc: 0
autonumber-headings: 1
mathjax: 0
---

Hello world! <span lang="fr">Bonjour le monde !</span> <span lang="es">¡Hola mundo!</span> <span lang="vi">Xin chào thế giới!</span>
```

</blockquote>

В приведённом выше примере текст будет озвучен на четырёх языках, при условии, что используемый вами синтезатор речи поддерживает автоматическое переключение языков и в настройках речи NVDA установлен соответствующий флажок. Это будет звучать следующим образом:

> Hello World! <span lang="fr">Bonjour tout le monde!</span> <span lang="es">¡Hola mundo!</span> <span lang="vi">Xin chào thế giới!</span>


## Дополнительные теги

Дополнительные теги - это специальные заполнители, которые вы можете поместить в содержимое Markdown для автоматического добавления системной информации, например, текущей даты или времени, которые будут отображаться в HTML-документе открытым текстом.

### Поддерживаемые дополнительные теги

| **В контенте в формате Markdown** | **Пояснение** | **Результат в браузере** |
| :----------: | :----------: | :----------: |
| `%date%` | Current date | %date% |
| `%time%` | Current time | %time% |
| `%now%` | Current date / time | %now% |
| `%day%` | Current day (long format) | %day% |
| `%dday%` | Current day (decimal format) | %dday% |
| `%month%` | Month (long format) | %month% |
| `%dmonth%` | Current month (decimal format) | %dmonth% |
| `%year%` | Текущий год (2 цифры) | %year% |
| `%Year%` | Текущий год (4 цифры) | %Year% |
| | `%toc%` | Оглавление в позиции курсора (если включено через метаданные или настройки по умолчанию) | N/A |

## Настройки MarkdownForever по умолчанию.

Они доступны из меню NVDA -> Настройки MarkdownForever -> Настройки и позволяют настроить и установить по умолчанию различные параметры, связанные с процессом преобразования, о которых уже говорилось выше:

* "Создавать оглавление": Этот флажок позволит вам генерировать или не генерировать оглавление глав вашего конечного HTML-документа с кликабельными ссылками, ведущими на каждую главу. Это поведение также может быть задано для каждого документа с помощью ключа "toc" в блоке [optional metadata-block](#optional-metadata-block) и размещено в любом месте документа с помощью соответствующего [extra-tag.](#extra-tags)
* "Включить дополнительные теги": Если этот флажок установлен, это дает возможность использовать [специальные теги](#extra-tags) в вашем контенте Markdown для автоматической вставки таких вещей, как фактическая дата или время. Это поведение также может быть установлено для каждого документа с помощью ключа extratags в [дополнительном блоке метаданных](#optional-metadata-block).
* "Создавать соответствующие метаданные из HTML-источника": При преобразовании исходного HTML-файла в Markdown пытается угадать метаданные из исходного кода (название, lang, имя файла и т. д.) и сгенерировать для вас блок [метаданных](#optionnal-metadata-block).
* "Действие по умолчанию в интерактивном режиме": Позволяет выбрать действие по умолчанию, которое будет выполняться при нажатии клавиши Enter в [Интерактивном режиме:](#interactive-mode) Показать сгенерированный контент в браузере, в виртуальном буфере или поместить его в буфер обмена.
* "Движок Markdown":MarkdownForever позволяет выбирать между двумя движками конвертации, [HTML2Text](https://pypi.org/project/html2text/) и [HTML2Markdown.](https://pypi.org/project/html2markdown/) Просто экспериментируйте и выбирайте тот, который вам больше нравится, в зависимости от ваших потребностей или полученного результата.
* "Markdown2 extras": см. <https://github.com/trentm/python-markdown2/wiki/Extras>.* "Path":Здесь вы можете задать место сохранения по умолчанию на жестком диске для преобразованных документов. Это удобно, если вы всегда используете одну и ту же папку для хранения всех своих работ.
* "Управление HTML-шаблонами": Откроется диалоговое окно, позволяющее добавлять, редактировать и удалять HTML-шаблоны.С помощью шаблонов вы сможете настраивать визуальные аспекты создаваемых HTML-документов, используя CSS (каскадные таблицы стилей), язык, отвечающий за стилизацию страниц. Это позволит вам изменять цвета, макет или добавлять изображения в свои постановки и создавать шаблоны для каждой конкретной потребности.Конечно, в Интернете можно найти множество руководств по изучению CSS, и [это](https://www.htmldog.com/guides/css/beginner/) может стать хорошей отправной точкой.

## Краткое описание команд.

- *NVDA+CTRL+i*:Интерактивный режим.
- *NVDA+ALT+b*: Преобразование Markdown в HTML. Результат отображается в браузере по умолчанию.
- *NVDA+ALT+n*: Преобразование Markdown в HTML. Результат отображается в виртуальном просмотрщике NVDA.
- *NVDA+ALT+k*: Преобразование HTML в Markdown. Результат отображается в виртуальном просмотрщике NVDA.
- *NVDA+ALT+l*: Преобразование исходного текста Markdown в HTML. Результат отображается в виртуальном просмотрщике NVDA.
- *NVDA+SHIFT+g*:Преобразование HTML в Markdown. Результат копируется в буфер обмена.
- *NVDA+SHIFT+h*:Преобразование Markdown в форматированный HTML:Результат копируется в буфер обмена.
- *NVDA+CTRL+h*: Преобразование Markdown в исходный HTML. Результат копируется в буфер обмена.

## Информация о дополнении

* Авторы:
	- André &lt;<dev@andreabc.net>&gt;: создатель и основной сопровождающий дополнения.
	- Sof &lt;<hellosof@gmail.com>&gt;: английская и французская документация, различные предложения.
	- Виктор Цай: Китайская локализация.
- Данил Костенков &lt;danilkostenkov38@gmail.com&gt;: Русская локализация.
	- Чагры Доган, Умут Коркмаз: Турецкая локализация.
	- Rémy Ruiz &lt;<remyruiz@gmail.com>&gt;: Испанская локализация.
	- Dang Manh Cuong &lt;<dangmanhcuong@gmail.com>&gt;: Вьетнамская локализация.
	- И многие другие!
* Лицензия: GNU General Public License, версия 2
* Скачать [стабильную версию](https://andreabc.net/projects/NVDA_addons/markdownForever.nvda-addon)
* Скачать [версия для разработки](https://andreabc.net/projects/NVDA_addons/markdownForever.nvda-addon?channel=dev)
* Репозиторий GitHub: [aaclause/NVDA-markdownForever](https://github.com/aaclause/nvda-markdownForever)
* **Included dependencies**: